#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private GaplessADX[] cacheGaplessADX;
		private GaplessATR[] cacheGaplessATR;
		private GaplessBands[] cacheGaplessBands;
		private GaplessCCI[] cacheGaplessCCI;
		private GaplessDI[] cacheGaplessDI;
		private GaplessEMA[] cacheGaplessEMA;
		private GaplessHMA[] cacheGaplessHMA;
		private GaplessLinearRegression[] cacheGaplessLinearRegression;
		private GaplessMACD[] cacheGaplessMACD;
		private GaplessParabolicSAR[] cacheGaplessParabolicSAR;
		private GaplessRSI[] cacheGaplessRSI;
		private GaplessSMA[] cacheGaplessSMA;
		private GaplessStochastics[] cacheGaplessStochastics;
		private GaplessSupportResistance[] cacheGaplessSupportResistance;
		private GaplessWMA[] cacheGaplessWMA;

		
		public GaplessADX GaplessADX(int period)
		{
			return GaplessADX(Input, period);
		}

		public GaplessATR GaplessATR(int period)
		{
			return GaplessATR(Input, period);
		}

		public GaplessBands GaplessBands(double numStdDev, int period)
		{
			return GaplessBands(Input, numStdDev, period);
		}

		public GaplessCCI GaplessCCI(int period)
		{
			return GaplessCCI(Input, period);
		}

		public GaplessDI GaplessDI(int period)
		{
			return GaplessDI(Input, period);
		}

		public GaplessEMA GaplessEMA(int period)
		{
			return GaplessEMA(Input, period);
		}

		public GaplessHMA GaplessHMA(int period)
		{
			return GaplessHMA(Input, period);
		}

		public GaplessLinearRegression GaplessLinearRegression(int period)
		{
			return GaplessLinearRegression(Input, period);
		}

		public GaplessMACD GaplessMACD(int fast, int slow, int smooth)
		{
			return GaplessMACD(Input, fast, slow, smooth);
		}

		public GaplessParabolicSAR GaplessParabolicSAR(double acceleration, double accelerationMax, double accelerationStep)
		{
			return GaplessParabolicSAR(Input, acceleration, accelerationMax, accelerationStep);
		}

		public GaplessRSI GaplessRSI(int period, int smooth)
		{
			return GaplessRSI(Input, period, smooth);
		}

		public GaplessSMA GaplessSMA(int period)
		{
			return GaplessSMA(Input, period);
		}

		public GaplessStochastics GaplessStochastics(int periodD, int periodK, int smooth)
		{
			return GaplessStochastics(Input, periodD, periodK, smooth);
		}

		public GaplessSupportResistance GaplessSupportResistance(int period)
		{
			return GaplessSupportResistance(Input, period);
		}

		public GaplessWMA GaplessWMA(int period)
		{
			return GaplessWMA(Input, period);
		}


		
		public GaplessADX GaplessADX(ISeries<double> input, int period)
		{
			if (cacheGaplessADX != null)
				for (int idx = 0; idx < cacheGaplessADX.Length; idx++)
					if (cacheGaplessADX[idx].Period == period && cacheGaplessADX[idx].EqualsInput(input))
						return cacheGaplessADX[idx];
			return CacheIndicator<GaplessADX>(new GaplessADX(){ Period = period }, input, ref cacheGaplessADX);
		}

		public GaplessATR GaplessATR(ISeries<double> input, int period)
		{
			if (cacheGaplessATR != null)
				for (int idx = 0; idx < cacheGaplessATR.Length; idx++)
					if (cacheGaplessATR[idx].Period == period && cacheGaplessATR[idx].EqualsInput(input))
						return cacheGaplessATR[idx];
			return CacheIndicator<GaplessATR>(new GaplessATR(){ Period = period }, input, ref cacheGaplessATR);
		}

		public GaplessBands GaplessBands(ISeries<double> input, double numStdDev, int period)
		{
			if (cacheGaplessBands != null)
				for (int idx = 0; idx < cacheGaplessBands.Length; idx++)
					if (cacheGaplessBands[idx].NumStdDev == numStdDev && cacheGaplessBands[idx].Period == period && cacheGaplessBands[idx].EqualsInput(input))
						return cacheGaplessBands[idx];
			return CacheIndicator<GaplessBands>(new GaplessBands(){ NumStdDev = numStdDev, Period = period }, input, ref cacheGaplessBands);
		}

		public GaplessCCI GaplessCCI(ISeries<double> input, int period)
		{
			if (cacheGaplessCCI != null)
				for (int idx = 0; idx < cacheGaplessCCI.Length; idx++)
					if (cacheGaplessCCI[idx].Period == period && cacheGaplessCCI[idx].EqualsInput(input))
						return cacheGaplessCCI[idx];
			return CacheIndicator<GaplessCCI>(new GaplessCCI(){ Period = period }, input, ref cacheGaplessCCI);
		}

		public GaplessDI GaplessDI(ISeries<double> input, int period)
		{
			if (cacheGaplessDI != null)
				for (int idx = 0; idx < cacheGaplessDI.Length; idx++)
					if (cacheGaplessDI[idx].Period == period && cacheGaplessDI[idx].EqualsInput(input))
						return cacheGaplessDI[idx];
			return CacheIndicator<GaplessDI>(new GaplessDI(){ Period = period }, input, ref cacheGaplessDI);
		}

		public GaplessEMA GaplessEMA(ISeries<double> input, int period)
		{
			if (cacheGaplessEMA != null)
				for (int idx = 0; idx < cacheGaplessEMA.Length; idx++)
					if (cacheGaplessEMA[idx].Period == period && cacheGaplessEMA[idx].EqualsInput(input))
						return cacheGaplessEMA[idx];
			return CacheIndicator<GaplessEMA>(new GaplessEMA(){ Period = period }, input, ref cacheGaplessEMA);
		}

		public GaplessHMA GaplessHMA(ISeries<double> input, int period)
		{
			if (cacheGaplessHMA != null)
				for (int idx = 0; idx < cacheGaplessHMA.Length; idx++)
					if (cacheGaplessHMA[idx].Period == period && cacheGaplessHMA[idx].EqualsInput(input))
						return cacheGaplessHMA[idx];
			return CacheIndicator<GaplessHMA>(new GaplessHMA(){ Period = period }, input, ref cacheGaplessHMA);
		}

		public GaplessLinearRegression GaplessLinearRegression(ISeries<double> input, int period)
		{
			if (cacheGaplessLinearRegression != null)
				for (int idx = 0; idx < cacheGaplessLinearRegression.Length; idx++)
					if (cacheGaplessLinearRegression[idx].Period == period && cacheGaplessLinearRegression[idx].EqualsInput(input))
						return cacheGaplessLinearRegression[idx];
			return CacheIndicator<GaplessLinearRegression>(new GaplessLinearRegression(){ Period = period }, input, ref cacheGaplessLinearRegression);
		}

		public GaplessMACD GaplessMACD(ISeries<double> input, int fast, int slow, int smooth)
		{
			if (cacheGaplessMACD != null)
				for (int idx = 0; idx < cacheGaplessMACD.Length; idx++)
					if (cacheGaplessMACD[idx].Fast == fast && cacheGaplessMACD[idx].Slow == slow && cacheGaplessMACD[idx].Smooth == smooth && cacheGaplessMACD[idx].EqualsInput(input))
						return cacheGaplessMACD[idx];
			return CacheIndicator<GaplessMACD>(new GaplessMACD(){ Fast = fast, Slow = slow, Smooth = smooth }, input, ref cacheGaplessMACD);
		}

		public GaplessParabolicSAR GaplessParabolicSAR(ISeries<double> input, double acceleration, double accelerationMax, double accelerationStep)
		{
			if (cacheGaplessParabolicSAR != null)
				for (int idx = 0; idx < cacheGaplessParabolicSAR.Length; idx++)
					if (cacheGaplessParabolicSAR[idx].Acceleration == acceleration && cacheGaplessParabolicSAR[idx].AccelerationMax == accelerationMax && cacheGaplessParabolicSAR[idx].AccelerationStep == accelerationStep && cacheGaplessParabolicSAR[idx].EqualsInput(input))
						return cacheGaplessParabolicSAR[idx];
			return CacheIndicator<GaplessParabolicSAR>(new GaplessParabolicSAR(){ Acceleration = acceleration, AccelerationMax = accelerationMax, AccelerationStep = accelerationStep }, input, ref cacheGaplessParabolicSAR);
		}

		public GaplessRSI GaplessRSI(ISeries<double> input, int period, int smooth)
		{
			if (cacheGaplessRSI != null)
				for (int idx = 0; idx < cacheGaplessRSI.Length; idx++)
					if (cacheGaplessRSI[idx].Period == period && cacheGaplessRSI[idx].Smooth == smooth && cacheGaplessRSI[idx].EqualsInput(input))
						return cacheGaplessRSI[idx];
			return CacheIndicator<GaplessRSI>(new GaplessRSI(){ Period = period, Smooth = smooth }, input, ref cacheGaplessRSI);
		}

		public GaplessSMA GaplessSMA(ISeries<double> input, int period)
		{
			if (cacheGaplessSMA != null)
				for (int idx = 0; idx < cacheGaplessSMA.Length; idx++)
					if (cacheGaplessSMA[idx].Period == period && cacheGaplessSMA[idx].EqualsInput(input))
						return cacheGaplessSMA[idx];
			return CacheIndicator<GaplessSMA>(new GaplessSMA(){ Period = period }, input, ref cacheGaplessSMA);
		}

		public GaplessStochastics GaplessStochastics(ISeries<double> input, int periodD, int periodK, int smooth)
		{
			if (cacheGaplessStochastics != null)
				for (int idx = 0; idx < cacheGaplessStochastics.Length; idx++)
					if (cacheGaplessStochastics[idx].PeriodD == periodD && cacheGaplessStochastics[idx].PeriodK == periodK && cacheGaplessStochastics[idx].Smooth == smooth && cacheGaplessStochastics[idx].EqualsInput(input))
						return cacheGaplessStochastics[idx];
			return CacheIndicator<GaplessStochastics>(new GaplessStochastics(){ PeriodD = periodD, PeriodK = periodK, Smooth = smooth }, input, ref cacheGaplessStochastics);
		}

		public GaplessSupportResistance GaplessSupportResistance(ISeries<double> input, int period)
		{
			if (cacheGaplessSupportResistance != null)
				for (int idx = 0; idx < cacheGaplessSupportResistance.Length; idx++)
					if (cacheGaplessSupportResistance[idx].Period == period && cacheGaplessSupportResistance[idx].EqualsInput(input))
						return cacheGaplessSupportResistance[idx];
			return CacheIndicator<GaplessSupportResistance>(new GaplessSupportResistance(){ Period = period }, input, ref cacheGaplessSupportResistance);
		}

		public GaplessWMA GaplessWMA(ISeries<double> input, int period)
		{
			if (cacheGaplessWMA != null)
				for (int idx = 0; idx < cacheGaplessWMA.Length; idx++)
					if (cacheGaplessWMA[idx].Period == period && cacheGaplessWMA[idx].EqualsInput(input))
						return cacheGaplessWMA[idx];
			return CacheIndicator<GaplessWMA>(new GaplessWMA(){ Period = period }, input, ref cacheGaplessWMA);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.GaplessADX GaplessADX(int period)
		{
			return indicator.GaplessADX(Input, period);
		}

		public Indicators.GaplessATR GaplessATR(int period)
		{
			return indicator.GaplessATR(Input, period);
		}

		public Indicators.GaplessBands GaplessBands(double numStdDev, int period)
		{
			return indicator.GaplessBands(Input, numStdDev, period);
		}

		public Indicators.GaplessCCI GaplessCCI(int period)
		{
			return indicator.GaplessCCI(Input, period);
		}

		public Indicators.GaplessDI GaplessDI(int period)
		{
			return indicator.GaplessDI(Input, period);
		}

		public Indicators.GaplessEMA GaplessEMA(int period)
		{
			return indicator.GaplessEMA(Input, period);
		}

		public Indicators.GaplessHMA GaplessHMA(int period)
		{
			return indicator.GaplessHMA(Input, period);
		}

		public Indicators.GaplessLinearRegression GaplessLinearRegression(int period)
		{
			return indicator.GaplessLinearRegression(Input, period);
		}

		public Indicators.GaplessMACD GaplessMACD(int fast, int slow, int smooth)
		{
			return indicator.GaplessMACD(Input, fast, slow, smooth);
		}

		public Indicators.GaplessParabolicSAR GaplessParabolicSAR(double acceleration, double accelerationMax, double accelerationStep)
		{
			return indicator.GaplessParabolicSAR(Input, acceleration, accelerationMax, accelerationStep);
		}

		public Indicators.GaplessRSI GaplessRSI(int period, int smooth)
		{
			return indicator.GaplessRSI(Input, period, smooth);
		}

		public Indicators.GaplessSMA GaplessSMA(int period)
		{
			return indicator.GaplessSMA(Input, period);
		}

		public Indicators.GaplessStochastics GaplessStochastics(int periodD, int periodK, int smooth)
		{
			return indicator.GaplessStochastics(Input, periodD, periodK, smooth);
		}

		public Indicators.GaplessSupportResistance GaplessSupportResistance(int period)
		{
			return indicator.GaplessSupportResistance(Input, period);
		}

		public Indicators.GaplessWMA GaplessWMA(int period)
		{
			return indicator.GaplessWMA(Input, period);
		}


		
		public Indicators.GaplessADX GaplessADX(ISeries<double> input , int period)
		{
			return indicator.GaplessADX(input, period);
		}

		public Indicators.GaplessATR GaplessATR(ISeries<double> input , int period)
		{
			return indicator.GaplessATR(input, period);
		}

		public Indicators.GaplessBands GaplessBands(ISeries<double> input , double numStdDev, int period)
		{
			return indicator.GaplessBands(input, numStdDev, period);
		}

		public Indicators.GaplessCCI GaplessCCI(ISeries<double> input , int period)
		{
			return indicator.GaplessCCI(input, period);
		}

		public Indicators.GaplessDI GaplessDI(ISeries<double> input , int period)
		{
			return indicator.GaplessDI(input, period);
		}

		public Indicators.GaplessEMA GaplessEMA(ISeries<double> input , int period)
		{
			return indicator.GaplessEMA(input, period);
		}

		public Indicators.GaplessHMA GaplessHMA(ISeries<double> input , int period)
		{
			return indicator.GaplessHMA(input, period);
		}

		public Indicators.GaplessLinearRegression GaplessLinearRegression(ISeries<double> input , int period)
		{
			return indicator.GaplessLinearRegression(input, period);
		}

		public Indicators.GaplessMACD GaplessMACD(ISeries<double> input , int fast, int slow, int smooth)
		{
			return indicator.GaplessMACD(input, fast, slow, smooth);
		}

		public Indicators.GaplessParabolicSAR GaplessParabolicSAR(ISeries<double> input , double acceleration, double accelerationMax, double accelerationStep)
		{
			return indicator.GaplessParabolicSAR(input, acceleration, accelerationMax, accelerationStep);
		}

		public Indicators.GaplessRSI GaplessRSI(ISeries<double> input , int period, int smooth)
		{
			return indicator.GaplessRSI(input, period, smooth);
		}

		public Indicators.GaplessSMA GaplessSMA(ISeries<double> input , int period)
		{
			return indicator.GaplessSMA(input, period);
		}

		public Indicators.GaplessStochastics GaplessStochastics(ISeries<double> input , int periodD, int periodK, int smooth)
		{
			return indicator.GaplessStochastics(input, periodD, periodK, smooth);
		}

		public Indicators.GaplessSupportResistance GaplessSupportResistance(ISeries<double> input , int period)
		{
			return indicator.GaplessSupportResistance(input, period);
		}

		public Indicators.GaplessWMA GaplessWMA(ISeries<double> input , int period)
		{
			return indicator.GaplessWMA(input, period);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.GaplessADX GaplessADX(int period)
		{
			return indicator.GaplessADX(Input, period);
		}

		public Indicators.GaplessATR GaplessATR(int period)
		{
			return indicator.GaplessATR(Input, period);
		}

		public Indicators.GaplessBands GaplessBands(double numStdDev, int period)
		{
			return indicator.GaplessBands(Input, numStdDev, period);
		}

		public Indicators.GaplessCCI GaplessCCI(int period)
		{
			return indicator.GaplessCCI(Input, period);
		}

		public Indicators.GaplessDI GaplessDI(int period)
		{
			return indicator.GaplessDI(Input, period);
		}

		public Indicators.GaplessEMA GaplessEMA(int period)
		{
			return indicator.GaplessEMA(Input, period);
		}

		public Indicators.GaplessHMA GaplessHMA(int period)
		{
			return indicator.GaplessHMA(Input, period);
		}

		public Indicators.GaplessLinearRegression GaplessLinearRegression(int period)
		{
			return indicator.GaplessLinearRegression(Input, period);
		}

		public Indicators.GaplessMACD GaplessMACD(int fast, int slow, int smooth)
		{
			return indicator.GaplessMACD(Input, fast, slow, smooth);
		}

		public Indicators.GaplessParabolicSAR GaplessParabolicSAR(double acceleration, double accelerationMax, double accelerationStep)
		{
			return indicator.GaplessParabolicSAR(Input, acceleration, accelerationMax, accelerationStep);
		}

		public Indicators.GaplessRSI GaplessRSI(int period, int smooth)
		{
			return indicator.GaplessRSI(Input, period, smooth);
		}

		public Indicators.GaplessSMA GaplessSMA(int period)
		{
			return indicator.GaplessSMA(Input, period);
		}

		public Indicators.GaplessStochastics GaplessStochastics(int periodD, int periodK, int smooth)
		{
			return indicator.GaplessStochastics(Input, periodD, periodK, smooth);
		}

		public Indicators.GaplessSupportResistance GaplessSupportResistance(int period)
		{
			return indicator.GaplessSupportResistance(Input, period);
		}

		public Indicators.GaplessWMA GaplessWMA(int period)
		{
			return indicator.GaplessWMA(Input, period);
		}


		
		public Indicators.GaplessADX GaplessADX(ISeries<double> input , int period)
		{
			return indicator.GaplessADX(input, period);
		}

		public Indicators.GaplessATR GaplessATR(ISeries<double> input , int period)
		{
			return indicator.GaplessATR(input, period);
		}

		public Indicators.GaplessBands GaplessBands(ISeries<double> input , double numStdDev, int period)
		{
			return indicator.GaplessBands(input, numStdDev, period);
		}

		public Indicators.GaplessCCI GaplessCCI(ISeries<double> input , int period)
		{
			return indicator.GaplessCCI(input, period);
		}

		public Indicators.GaplessDI GaplessDI(ISeries<double> input , int period)
		{
			return indicator.GaplessDI(input, period);
		}

		public Indicators.GaplessEMA GaplessEMA(ISeries<double> input , int period)
		{
			return indicator.GaplessEMA(input, period);
		}

		public Indicators.GaplessHMA GaplessHMA(ISeries<double> input , int period)
		{
			return indicator.GaplessHMA(input, period);
		}

		public Indicators.GaplessLinearRegression GaplessLinearRegression(ISeries<double> input , int period)
		{
			return indicator.GaplessLinearRegression(input, period);
		}

		public Indicators.GaplessMACD GaplessMACD(ISeries<double> input , int fast, int slow, int smooth)
		{
			return indicator.GaplessMACD(input, fast, slow, smooth);
		}

		public Indicators.GaplessParabolicSAR GaplessParabolicSAR(ISeries<double> input , double acceleration, double accelerationMax, double accelerationStep)
		{
			return indicator.GaplessParabolicSAR(input, acceleration, accelerationMax, accelerationStep);
		}

		public Indicators.GaplessRSI GaplessRSI(ISeries<double> input , int period, int smooth)
		{
			return indicator.GaplessRSI(input, period, smooth);
		}

		public Indicators.GaplessSMA GaplessSMA(ISeries<double> input , int period)
		{
			return indicator.GaplessSMA(input, period);
		}

		public Indicators.GaplessStochastics GaplessStochastics(ISeries<double> input , int periodD, int periodK, int smooth)
		{
			return indicator.GaplessStochastics(input, periodD, periodK, smooth);
		}

		public Indicators.GaplessSupportResistance GaplessSupportResistance(ISeries<double> input , int period)
		{
			return indicator.GaplessSupportResistance(input, period);
		}

		public Indicators.GaplessWMA GaplessWMA(ISeries<double> input , int period)
		{
			return indicator.GaplessWMA(input, period);
		}

	}
}

#endregion
